/* 
Projecte ascensor de 3 pisos controlat amb 3 botons
Accedeix al pis del botó premut 
El motor es desplaça a les 3 posicions expressades pels passos necessaris per arribar-hi.
Robòtica educativa - CRP del Tarragonès
*/
// Configuracions
int planta0   = 7;  // Port del polsador de la planta 0
int planta1   = 6;  // Port del polsador de la planta 1
int planta2   = 5;  // Port del polsador de la planta 2
int IN4       = 11;  // Port del pin IN4 del mòdul ULN2003
int IN3       = 10;  // Port del pin IN3 del mòdul ULN2003
int IN2       =  9;  // Port del pin IN2 del mòdul ULN2003
int IN1       =  8;  // Port del pin IN1 del mòdul ULN2003

// Variables
int retard    = 2;   // Temps de retard entre els passos del motor
int numPassos = 0;   // Guarda en passos el punt on s'ha de situar el motor
int numPlanta = 0;   // Guarda en passos el punt on es troba el motor

void setup() {                
Serial.begin(9600);        // Inicialització del port sèrie a 9600 baudis
pinMode(IN4, OUTPUT);      // Sortida del senyal a IN4 del mòdul ULN2003
pinMode(IN3, OUTPUT);      // Sortida del senyal a IN3 del mòdul ULN2003
pinMode(IN2, OUTPUT);      // Sortida del senyal a IN2 del mòdul ULN2003
pinMode(IN1, OUTPUT);      // Sortida del senyal a IN1 del mòdul ULN2003
pinMode(planta0, INPUT);   // Entrada de valor del polsador planta 0
pinMode(planta1, INPUT);   // Entrada de valor del polsador planta 1
pinMode(planta2, INPUT);   // Entrada de valor del polsador planta 2
}

void loop() {

  if(digitalRead(planta0)==HIGH){        // Configura la situació de la planta 0 en passos
    numPassos = 0; 
    Serial.println("Petició Planta 0");
    }    
  if(digitalRead(planta1)==HIGH){        // Configura la situació de la planta 1 en passos
    numPassos = 2210; 
    Serial.println("Petició Planta 1");
    } 
  if(digitalRead(planta2)==HIGH){        // Configura la situació de la planta 2 en passos   
    numPassos = 4210; 
    Serial.println("Petició Planta 2");
    }

  if(numPassos != numPlanta){
    while (numPassos > numPlanta){   // Puja l'ascensor
        pisAmunt();
        numPlanta = numPlanta + 1;
        }
    while (numPassos < numPlanta){   // Baixa l'ascensor
        pisAvall();
        numPlanta = numPlanta -1;
        }
      }
  atura();                           // Atura del motor per tal d'evitar que es calenti
}

void pisAmunt(){                     // Passos amunt (el motor gira en sentit horari)
 digitalWrite(IN4, LOW); 
 digitalWrite(IN3, LOW);  
 digitalWrite(IN2, HIGH);  
 digitalWrite(IN1, HIGH);  
 delay(retard); 
 digitalWrite(IN4, LOW); 
 digitalWrite(IN3, HIGH);  
 digitalWrite(IN2, HIGH);  
 digitalWrite(IN1, LOW);  
 delay(retard); 
 digitalWrite(IN4, HIGH); 
 digitalWrite(IN3, HIGH);  
 digitalWrite(IN2, LOW);  
 digitalWrite(IN1, LOW);  
 delay(retard); 
 digitalWrite(IN4, HIGH); 
 digitalWrite(IN3, LOW);  
 digitalWrite(IN2, LOW);  
 digitalWrite(IN1, HIGH);  
 delay(retard);  
}

void pisAvall() {                    // Passos avall (el motor gira en sentit anti-horari)
 digitalWrite(IN4, HIGH); 
 digitalWrite(IN3, HIGH);  
 digitalWrite(IN2, LOW);  
 digitalWrite(IN1, LOW);  
 delay(retard); 
 digitalWrite(IN4, LOW); 
 digitalWrite(IN3, HIGH);  
 digitalWrite(IN2, HIGH);  
 digitalWrite(IN1, LOW);  
 delay(retard); 
 digitalWrite(IN4, LOW); 
 digitalWrite(IN3, LOW);  
 digitalWrite(IN2, HIGH);  
 digitalWrite(IN1, HIGH);  
 delay(retard); 
 digitalWrite(IN4, HIGH); 
 digitalWrite(IN3, LOW);  
 digitalWrite(IN2, LOW);  
 digitalWrite(IN1, HIGH);  
 delay(retard); 
}
        
void atura() {                       // Atura del motor
 digitalWrite(IN4, LOW); 
 digitalWrite(IN3, LOW);  
 digitalWrite(IN2, LOW);  
 digitalWrite(IN1, LOW);  
 }
